import type { NobjcObject } from "objc-js";
import type { _NSChangeSpelling } from "./NSChangeSpelling.js";
import type { _NSColor } from "./NSColor.js";
import type { _NSFont } from "./NSFont.js";
import type { _NSIgnoreMisspelledWords } from "./NSIgnoreMisspelledWords.js";
import type { _NSTableView } from "./NSTableView.js";
import type { _NSTextDelegate } from "./NSTextDelegate.js";
import type { _NSView } from "./NSView.js";
import type { _NSCoder } from "../Foundation/NSCoder.js";
import type { _NSData } from "../Foundation/NSData.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _SLComposeServiceViewController } from "../Social/SLComposeServiceViewController.js";
import type { CGRect } from "../structs/CGRect.js";
import type { CGSize } from "../structs/CGSize.js";
import type { NSRange } from "../structs/NSRange.js";
import type { NSTextAlignment } from "./NSTextAlignment.js";
import type { NSWritingDirection } from "./NSWritingDirection.js";
export declare class _NSText extends _NSView {
    static alloc(): _NSText;
    static new(): _NSText;
    init(): _NSText;
    initWithFrame$(frameRect: CGRect): _NSText;
    initWithCoder$(coder: _NSCoder): _NSText | null;
    replaceCharactersInRange$withString$(range: NSRange, string_: _NSString): void;
    replaceCharactersInRange$withRTF$(range: NSRange, rtfData: _NSData): void;
    replaceCharactersInRange$withRTFD$(range: NSRange, rtfdData: _NSData): void;
    RTFFromRange$(range: NSRange): _NSData | null;
    RTFDFromRange$(range: NSRange): _NSData | null;
    writeRTFDToFile$atomically$(path: _NSString, flag: boolean): boolean;
    readRTFDFromFile$(path: _NSString): boolean;
    scrollRangeToVisible$(range: NSRange): void;
    /** Passing nil removes NSForegroundColorAttributeName from range */
    setTextColor$range$(color: _NSColor | null, range: NSRange): void;
    setFont$range$(font: _NSFont, range: NSRange): void;
    sizeToFit(): void;
    copy$(sender: NobjcObject | null): void;
    copyFont$(sender: NobjcObject | null): void;
    copyRuler$(sender: NobjcObject | null): void;
    cut$(sender: NobjcObject | null): void;
    delete$(sender: NobjcObject | null): void;
    paste$(sender: NobjcObject | null): void;
    pasteFont$(sender: NobjcObject | null): void;
    pasteRuler$(sender: NobjcObject | null): void;
    selectAll$(sender: NobjcObject | null): void;
    changeFont$(sender: NobjcObject | null): void;
    alignLeft$(sender: NobjcObject | null): void;
    alignRight$(sender: NobjcObject | null): void;
    alignCenter$(sender: NobjcObject | null): void;
    subscript$(sender: NobjcObject | null): void;
    superscript$(sender: NobjcObject | null): void;
    underline$(sender: NobjcObject | null): void;
    unscript$(sender: NobjcObject | null): void;
    showGuessPanel$(sender: NobjcObject | null): void;
    checkSpelling$(sender: NobjcObject | null): void;
    toggleRuler$(sender: NobjcObject | null): void;
    string(): _NSString;
    setString$(value: _NSString): void;
    delegate(): _NSTableView | _SLComposeServiceViewController | null;
    setDelegate$(value: _NSTextDelegate | null): void;
    editable(): boolean;
    setEditable$(value: boolean): void;
    selectable(): boolean;
    setSelectable$(value: boolean): void;
    /** If NO, also clears setImportsGraphics: */
    richText(): boolean;
    setRichText$(value: boolean): void;
    /** If YES, also sets setRichText: */
    importsGraphics(): boolean;
    setImportsGraphics$(value: boolean): void;
    /** Indicates whether to end editing on CR, TAB, etc. */
    fieldEditor(): boolean;
    setFieldEditor$(value: boolean): void;
    usesFontPanel(): boolean;
    setUsesFontPanel$(value: boolean): void;
    drawsBackground(): boolean;
    setDrawsBackground$(value: boolean): void;
    /** Default is nil. If nil, it implies -drawsBackground=NO */
    backgroundColor(): _NSColor | null;
    setBackgroundColor$(value: _NSColor | null): void;
    rulerVisible(): boolean;
    selectedRange(): NSRange;
    setSelectedRange$(value: NSRange): void;
    font(): _NSFont | null;
    setFont$(value: _NSFont | null): void;
    /** Default is nil. If nil, draws with blackColor */
    textColor(): _NSColor | null;
    setTextColor$(value: _NSColor | null): void;
    alignment(): NSTextAlignment;
    setAlignment$(value: NSTextAlignment): void;
    baseWritingDirection(): NSWritingDirection;
    setBaseWritingDirection$(value: NSWritingDirection): void;
    maxSize(): CGSize;
    setMaxSize$(value: CGSize): void;
    minSize(): CGSize;
    setMinSize$(value: CGSize): void;
    horizontallyResizable(): boolean;
    setHorizontallyResizable$(value: boolean): void;
    verticallyResizable(): boolean;
    setVerticallyResizable$(value: boolean): void;
}
export interface _NSText extends _NSChangeSpelling, _NSIgnoreMisspelledWords {
}
